resource "hcloud_network" "us_east" {
  name     = "us-east"
  ip_range = "10.128.0.0/10"
}

resource "hcloud_network_subnet" "lan" {
  network_id   = hcloud_network.us_east.id
  type         = "cloud"
  network_zone = "us-east"
  ip_range     = "10.128.1.0/24"
}

resource "hcloud_network_subnet" "sync" {
  network_id   = hcloud_network.us_east.id
  type         = "cloud"
  network_zone = "us-east"
  ip_range     = "10.128.2.0/24"
}

resource "hcloud_network_subnet" "cluster" {
  network_id   = hcloud_network.us_east.id
  type         = "cloud"
  network_zone = "us-east"
  ip_range     = "10.128.3.0/24"
}

resource "hcloud_primary_ip" "opnsense_a_v4" {
  name = "opnsense-a-v4"
  type = "ipv4"
  datacenter = "ash-dc1"
  auto_delete = false
  delete_protection = true
  assignee_type = "server"
}

resource "hcloud_primary_ip" "opnsense_b_v4" {
  name = "opnsense-b-v4"
  type = "ipv4"
  datacenter = "ash-dc1"
  auto_delete = false
  delete_protection = true
  assignee_type = "server"
}

resource "hcloud_primary_ip" "opnsense_a_v6" {
  name = "opnsense-a-v6"
  type = "ipv6"
  datacenter = "ash-dc1"
  auto_delete = false
  delete_protection = true
  assignee_type = "server"
}

resource "hcloud_primary_ip" "opnsense_b_v6" {
  name = "opnsense-b-v6"
  type = "ipv6"
  datacenter = "ash-dc1"
  auto_delete = false
  delete_protection = true
  assignee_type = "server"
}

resource "hcloud_floating_ip" "opnsense_float_v4" {
  name = "opnsense-float-v4"
  type = "ipv4"
  home_location = "ash"
  delete_protection = true
}

resource "hcloud_floating_ip" "opnsense_float_v6" {
  name = "opnsense-float-v6"
  type = "ipv6"
  home_location = "ash"
  delete_protection = true
}